#!/bin/sh
#
# Test 2
#	Exercise the db_rename_file function
#
#	@(#)test_02.sh	1.5	09:31:23	3/30/92
#
set -e
RC=1
trap 'rm -f test_02.old test_02.new test_02 test_02.o test_02 stuff.dat stuff.idx ; exit $RC' 0 1 2 3 15

DBPATH=. ; export DBPATH
rm -f stuff.dat stuff.idx

./dbshow -v music songs > test_02.old

if [ ! -f test_02.c ]; then
	get s.test_02.c
fi
cc -o test_02 $CCFLAGS test_02.c libidbm.a $LDFLAGS
./test_02 music songs stuff

./dbshow -v music stuff > test_02.new
cmp -s - test_02.new << \EOF
database music

{ block size = 512 }

file stuff

{ record size = 80, block size = 4096 }

field	.stuff	type	index unique
field	sng_title	type	char length 60
field	sng_title_idx	type	index	sng_title
field	sng_pub_key	type	char length 8
field	sng_cat_key	type	char length 8
field	sng_album_key	type	index	sng_pub_key, sng_cat_key
field	sng_track	type	int
field	sng_song_idx	type	index unique	sng_pub_key, sng_cat_key, sng_track

end
EOF
./test_02 music stuff songs
./dbshow -v music songs > test_02.new
cmp -s test_02.old test_02.new

RC=0
