/*
 * test 1
 *	exercise the db_desc_view() function
 *
 *	@(#)test_09.c	1.1	10:38:25	1/27/92
 */

#include <sys/types.h>
#include <stdio.h>
#include <fcntl.h>
#include "is_types.h"
#include "isam.h"

desc_t	song_file[] = {
	{ "sng_title",	T_CHAR,	60 },
	{ "sng_pub_key", T_CHAR, 8 },
	{ "sng_cat_key", T_CHAR, 8 },
	{ "sng_track", T_INT, 0 },
	{ (char *) 0, 0, 0 }
};

struct	song_record {
	char	sng_title[60];
	char	sng_pub_key[8];
	char	sng_cat_key[8];
	int	sng_track;
} *song_record;

main (argc, argv)
int	argc;
char	**argv;
{
	char	buf[BUFSIZ];
	int	filenum;
	long	record;
	dbm_t	*dbm;

	if (! (dbm = db_open ("music", O_RDONLY))) {
		fprintf (stderr, "cannot open database `music'\n");
		exit (1);
	}
	if ((filenum = db_open_file (dbm, "songs")) == -1) {
		fprintf (stderr, "cannot open file `songs'\n");
		exit (1);
	}
	if (! (song_record = (struct song_record *)
			db_desc_view (dbm, filenum, song_file, 0))) {
		fprintf (stderr, "cannot set descriptive view\n");
		exit (1);
	}
	if (db_open_index (dbm, filenum, "sng_song_idx") == -1) {
		fprintf (stderr, "cannot open index `sng_song_idx'\n");
		exit (1);
	}
	for (db_rewind (dbm, filenum);
			! db_read_view (dbm, filenum, (void *) 0, IS_NEXT);) {
		printf ("%.60s|%.8s|%.8s|%d\n",
			song_record->sng_title, song_record->sng_pub_key,
			song_record->sng_cat_key, song_record->sng_track);
	}
	exit (0);
}
